Class {
	#name : #GrafoscopioVisitor,
	#superclass : #Object,
	#category : 'Grafoscopio-Model'
}

{ #category : #visiting }
GrafoscopioVisitor >> visitBranchNode: aNode [
	self visitNode: aNode.
	aNode children do: [ : c | c acceptVisitor: self  ].
]

{ #category : #visiting }
GrafoscopioVisitor >> visitCodeNode: aNode [
	self visitNode: aNode
]

{ #category : #visiting }
GrafoscopioVisitor >> visitLeafNode: aNode [
	self visitNode: aNode
]

{ #category : #visiting }
GrafoscopioVisitor >> visitNode: aNode [
	" nothing to do here"
]

{ #category : #visiting }
GrafoscopioVisitor >> visitRootNode: aNode [
	self visitNode: aNode.
	aNode children do: [ : c | c acceptVisitor: self  ].
]

{ #category : #visiting }
GrafoscopioVisitor >> visitTextNode: aNode [
	self visitNode: aNode
]

{ #category : #visiting }
GrafoscopioVisitor >> visitUnitNode: aNode [
	self visitNode: aNode.
	aNode children do: [ : c | c acceptVisitor: self  ].
]

{ #category : #visiting }
GrafoscopioVisitor >> visitUrlNode: aNode [
	self visitNode: aNode
]
